/* Copyright (C) 2000 Decision Computer International, Inc.,
   This file is part of the Decision PCCOM development tool

   The pcomBarCode.c is a sample source code that demonstrate 
   how to use the development tool on serial bar code Reader device 
   using Decision PCCOM Serial cards. 

   The pcomBarCode.c is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
   See the GNU Library General Public License for more details. 
 
   -Armz27
*/

#include <stdio.h>
#include "libpccomprof.h"

int initReturn, openReturn, closeReturn;
size_t rxReturn; /* unsigned int txReturn; */
int intFlushOut, intFlushIn;
char strReceive[1000];

void StartOperation()
{
 openReturn = commopen("/dev/ttyS0");
 printf("commopen return %i\n\n", openReturn);
 sleep(1);

 initReturn = comminit("/dev/ttyS0", 9600, 8, "no", 1, "hardware");
 printf("comminit return %i\n\n", initReturn);
 sleep(1);
}

void FlushSample()
{
 printf("Cleaning the transmit buffer....");
 intFlushOut = commflushtx("/dev/ttyS0");
 printf("... done<return: %i>\n\n",intFlushOut);
 sleep(1);
 printf("Cleaning the receive buffer....");
 intFlushIn = commflushrx("/dev/ttyS0");
 printf("... done<return: %i>\n\n",intFlushIn);
 sleep(1);
}

void BarCodeScan()
{
int intMark = 0;
size_t intRXCounter = 0;
 printf("Please scan the bar code! \n");
 while (intMark == 0)
 { 
   intRXCounter = commgetRxCount("/dev/ttyS0");
   if (intRXCounter >= 1)
   {
      printf("Bar Code Scanner got %d number of data\nReceived:  ",intRXCounter);
      rxReturn = commrxblk("/dev/ttyS0", strReceive, intRXCounter);
      printf("%s", strReceive); 
      printf("\nReceive return %d\n\n", rxReturn);
      intMark = 1;
      sleep(1);
   } /* if end */
 } /* while end */
} 

void StopOperation()
{
 closeReturn = commclose("/dev/ttyS0");
 printf("commclose return %i\n\n", closeReturn);
}

int main()
{
 printf("\n\n\n\n");
 StartOperation();

 FlushSample();

 BarCodeScan();
 
 StopOperation();
 exit(0);
}
